--[[ DOWNLOAD LIB 
About :		This is a simple lib for download a large file,with progress status
Made by  :	Moritz Neikes
			Edited by Logan Tann for the kagerou project fangame only !!
			Under the MIT License (original file is in the public domain.),use files under the public domain.
Version :	1.0 (not optimized)
Comments : 	Edited for compatibility for the fangame.Please use only for the fangame,else,this may not work...
]]

download = {} --define the LUA class 

download.init = function() local self={}

	self.content = nil
	self.dl_status = nil
	self.requests_channel = love.thread.getChannel("requests")
	self.progress_channel = love.thread.getChannel("progress")
	self.queue = {}
	self.animationimg = love.graphics.newImage("resources/img/shintaroLoad.png")
		local animW,animH = self.animationimg:getWidth(),self.animationimg:getHeight()
		local g = anim8.newGrid(animW / 12,animH,animW,animH)
	self.animation = anim8.newAnimation(g('1-12',1), 0.1)
	self.frameW = animW/12
	self.progressbar = love.graphics.newImage("resources/img/progressbar.png")
	self.addqueue = function(url, output,comment)
		comment = comment or "Downloading..."
		table.insert(self.queue,{url = url,filename = output,comment = comment})
	end

	self.load = function()
		local downloader_thread = love.thread.newThread("downloader.lua")
  		downloader_thread:start()
	end

	self.start = function()
	  -- remove the previously loaded image
	  self.content = nil
	  -- reset the download status
	  self.dl_status = {
	    finished = false, -- whether the download has finished
	    downloaded = 0,   -- the total number of bytes that were downloaded so far
	    file_size = 0,    -- the size of the file
	  }

	  -- send the request to the downloader thread via the requests channel
	  self.requests_channel:push(self.queue[1])
	end

	self.update = function(dt)
		self.animation:update(dt)
		  -- Read all progress updates that came in since the last frame.
		  -- If there is no update, the returned value will be nil
		  local progress_update = self.progress_channel:pop()
		  while progress_update do

		    -- process the progress update
		    if progress_update.finished then
		      self.dl_status.finished = true
		      io.flush()
		      table.remove(self.queue,1)
		      if #self.queue > 0 then self.start() end
		    end
		    if progress_update.file_size then
		      self.dl_status.file_size = progress_update.file_size
		    end
		    if progress_update.chunk then
		      self.dl_status.downloaded = self.dl_status.downloaded + progress_update.chunk
		    end
		    if progress_update.err then
		      self.dl_status.err = progress_update.err
		    end

		    -- get the next progress update
		    -- If there is no update, the returned value will be nil
		    progress_update = self.progress_channel:pop()
		  end
	end

	self.display = function()
	if #self.queue > 0 then
		--config
			love.graphics.setFont(title)
			love.graphics.setBackgroundColor( 255,255,255 )
			love.graphics.setColor(255, 255, 255)

		--draw images
	  		self.animation:draw(self.animationimg,scrW/2 - self.frameW/2, 50)
	  		local progressX,progressY = scrW/2 - self.progressbar:getWidth()/4,self.animationimg:getHeight()+70
	  		love.graphics.draw(self.progressbar,progressX,progressY,0,0.5)

		--draw Text
			love.graphics.setColor(0, 0, 0)
			love.graphics.printf( "DOWNLOADING game resources", 0, 0, scrW, "center" )

			love.graphics.setFont(text)
			if self.dl_status then
			  if self.dl_status.file_size > 0 then
			    local perc =  self.dl_status.downloaded / self.dl_status.file_size
			    perc = math.floor(perc * 100)
			    love.graphics.rectangle("fill", progressX+53, progressY+10, perc*1.5, 27)
			    love.graphics.printf(string.format("%d%%", perc),0,scrH-70,scrW,"center")
			    love.graphics.printf(self.queue[1].comment,0,scrH-40,scrW,"center")
			  end
			  if self.dl_status.err then
			    love.graphics.print(self.dl_status.err, 0, 16)
			  end
			end
			return true
		else return false end
	end
return self end